/*
Copyright The Kubernetes Authors.

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/

// Code generated by client-gen. DO NOT EDIT.

package v1

import (
	v1 "github.com/submariner-io/submariner/pkg/apis/submariner.io/v1"
	"github.com/submariner-io/submariner/pkg/client/clientset/versioned/scheme"
	rest "k8s.io/client-go/rest"
)

type SubmarinerV1Interface interface {
	RESTClient() rest.Interface
	ClustersGetter
	ClusterGlobalEgressIPsGetter
	EndpointsGetter
	GatewaysGetter
	GlobalEgressIPsGetter
	GlobalIngressIPsGetter
}

// SubmarinerV1Client is used to interact with features provided by the submariner.io group.
type SubmarinerV1Client struct {
	restClient rest.Interface
}

func (c *SubmarinerV1Client) Clusters(namespace string) ClusterInterface {
	return newClusters(c, namespace)
}

func (c *SubmarinerV1Client) ClusterGlobalEgressIPs(namespace string) ClusterGlobalEgressIPInterface {
	return newClusterGlobalEgressIPs(c, namespace)
}

func (c *SubmarinerV1Client) Endpoints(namespace string) EndpointInterface {
	return newEndpoints(c, namespace)
}

func (c *SubmarinerV1Client) Gateways(namespace string) GatewayInterface {
	return newGateways(c, namespace)
}

func (c *SubmarinerV1Client) GlobalEgressIPs(namespace string) GlobalEgressIPInterface {
	return newGlobalEgressIPs(c, namespace)
}

func (c *SubmarinerV1Client) GlobalIngressIPs(namespace string) GlobalIngressIPInterface {
	return newGlobalIngressIPs(c, namespace)
}

// NewForConfig creates a new SubmarinerV1Client for the given config.
func NewForConfig(c *rest.Config) (*SubmarinerV1Client, error) {
	config := *c
	if err := setConfigDefaults(&config); err != nil {
		return nil, err
	}
	client, err := rest.RESTClientFor(&config)
	if err != nil {
		return nil, err
	}
	return &SubmarinerV1Client{client}, nil
}

// NewForConfigOrDie creates a new SubmarinerV1Client for the given config and
// panics if there is an error in the config.
func NewForConfigOrDie(c *rest.Config) *SubmarinerV1Client {
	client, err := NewForConfig(c)
	if err != nil {
		panic(err)
	}
	return client
}

// New creates a new SubmarinerV1Client for the given RESTClient.
func New(c rest.Interface) *SubmarinerV1Client {
	return &SubmarinerV1Client{c}
}

func setConfigDefaults(config *rest.Config) error {
	gv := v1.SchemeGroupVersion
	config.GroupVersion = &gv
	config.APIPath = "/apis"
	config.NegotiatedSerializer = scheme.Codecs.WithoutConversion()

	if config.UserAgent == "" {
		config.UserAgent = rest.DefaultKubernetesUserAgent()
	}

	return nil
}

// RESTClient returns a RESTClient that is used to communicate
// with API server by this client implementation.
func (c *SubmarinerV1Client) RESTClient() rest.Interface {
	if c == nil {
		return nil
	}
	return c.restClient
}
