/*
Copyright The Kubernetes Authors.

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/

// Code generated by informer-gen. DO NOT EDIT.

package v1

import (
	"context"
	time "time"

	submarineriov1 "github.com/submariner-io/submariner/pkg/apis/submariner.io/v1"
	versioned "github.com/submariner-io/submariner/pkg/client/clientset/versioned"
	internalinterfaces "github.com/submariner-io/submariner/pkg/client/informers/externalversions/internalinterfaces"
	v1 "github.com/submariner-io/submariner/pkg/client/listers/submariner.io/v1"
	metav1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	runtime "k8s.io/apimachinery/pkg/runtime"
	watch "k8s.io/apimachinery/pkg/watch"
	cache "k8s.io/client-go/tools/cache"
)

// ClusterGlobalEgressIPInformer provides access to a shared informer and lister for
// ClusterGlobalEgressIPs.
type ClusterGlobalEgressIPInformer interface {
	Informer() cache.SharedIndexInformer
	Lister() v1.ClusterGlobalEgressIPLister
}

type clusterGlobalEgressIPInformer struct {
	factory          internalinterfaces.SharedInformerFactory
	tweakListOptions internalinterfaces.TweakListOptionsFunc
	namespace        string
}

// NewClusterGlobalEgressIPInformer constructs a new informer for ClusterGlobalEgressIP type.
// Always prefer using an informer factory to get a shared informer instead of getting an independent
// one. This reduces memory footprint and number of connections to the server.
func NewClusterGlobalEgressIPInformer(client versioned.Interface, namespace string, resyncPeriod time.Duration, indexers cache.Indexers) cache.SharedIndexInformer {
	return NewFilteredClusterGlobalEgressIPInformer(client, namespace, resyncPeriod, indexers, nil)
}

// NewFilteredClusterGlobalEgressIPInformer constructs a new informer for ClusterGlobalEgressIP type.
// Always prefer using an informer factory to get a shared informer instead of getting an independent
// one. This reduces memory footprint and number of connections to the server.
func NewFilteredClusterGlobalEgressIPInformer(client versioned.Interface, namespace string, resyncPeriod time.Duration, indexers cache.Indexers, tweakListOptions internalinterfaces.TweakListOptionsFunc) cache.SharedIndexInformer {
	return cache.NewSharedIndexInformer(
		&cache.ListWatch{
			ListFunc: func(options metav1.ListOptions) (runtime.Object, error) {
				if tweakListOptions != nil {
					tweakListOptions(&options)
				}
				return client.SubmarinerV1().ClusterGlobalEgressIPs(namespace).List(context.TODO(), options)
			},
			WatchFunc: func(options metav1.ListOptions) (watch.Interface, error) {
				if tweakListOptions != nil {
					tweakListOptions(&options)
				}
				return client.SubmarinerV1().ClusterGlobalEgressIPs(namespace).Watch(context.TODO(), options)
			},
		},
		&submarineriov1.ClusterGlobalEgressIP{},
		resyncPeriod,
		indexers,
	)
}

func (f *clusterGlobalEgressIPInformer) defaultInformer(client versioned.Interface, resyncPeriod time.Duration) cache.SharedIndexInformer {
	return NewFilteredClusterGlobalEgressIPInformer(client, f.namespace, resyncPeriod, cache.Indexers{cache.NamespaceIndex: cache.MetaNamespaceIndexFunc}, f.tweakListOptions)
}

func (f *clusterGlobalEgressIPInformer) Informer() cache.SharedIndexInformer {
	return f.factory.InformerFor(&submarineriov1.ClusterGlobalEgressIP{}, f.defaultInformer)
}

func (f *clusterGlobalEgressIPInformer) Lister() v1.ClusterGlobalEgressIPLister {
	return v1.NewClusterGlobalEgressIPLister(f.Informer().GetIndexer())
}
